package tempest.app.manager.achievements;

import java.io.IOException;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.wb.swt.SWTResourceManager;

import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.utils.Array;
import com.badlogic.gdx.utils.XmlReader;
import com.badlogic.gdx.utils.XmlReader.Element;

public class AchievementParser {

	private Array<Element> elements;
	private Element current;
	private Element element;

	public void setFilename(String filename) {
		init(filename);
	}

	private void init(String filename) {
		XmlReader reader = new XmlReader();
		try {
			element = reader.parse(new FileHandle(filename));
			elements = new Array<Element>(element.getChildrenByName("achievement"));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void setCurrent(int index) {
		current = elements.get(index);
	}

	public void populate(Tree tree) throws IOException {
		for (Element e : elements) {
			TreeItem item = new TreeItem(tree, SWT.NONE);
			item.setText(e.getAttribute("type"));
			item.setImage(SWTResourceManager.getImage(AchievementParser.class, "/tempest/app/assets/achievement/achievement.png"));

			TreeItem id = new TreeItem(item , SWT.NONE);
			id.setText("ID: " + e.getAttribute("id"));
			id.setImage(SWTResourceManager.getImage(AchievementParser.class, "/tempest/app/assets/achievement/id.png"));

			TreeItem img = new TreeItem(item, SWT.NONE);
			img.setText("Image: " + e.getChildByName("img").getAttribute("path"));
			img.setImage(SWTResourceManager.getImage(AchievementParser.class, "/tempest/app/assets/achievement/img.png"));

			TreeItem goal = new TreeItem(item, SWT.NONE);
			goal.setText("Goals:");
			goal.setImage(SWTResourceManager.getImage(AchievementParser.class, "/tempest/app/assets/achievement/goals.png"));

			for (int i = 0; i < e.getChildByName("goal").getChildCount(); i++) {
				TreeItem type = new TreeItem(goal, SWT.NONE);
				type.setText(e.getChildByName("goal").getChild(i).getName() + ": " 
						+ e.getChildByName("goal").getChild(i).getText());
				type.setImage(SWTResourceManager.getImage(AchievementParser.class, "/tempest/app/assets/achievement/goal.png"));
			}
		}
	}
}
