package tempest.app.manager.achievements;

import java.io.File;
import java.io.IOException;
import java.net.URL;

import javax.xml.XMLConstants;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;

import org.eclipse.swt.SWT;
import org.eclipse.wb.swt.SWTResourceManager;
import org.xml.sax.SAXException;

import tempest.app.manager.composite.AchievementComposite;

public class AchievementValidator {
	private URL validator; 

	public AchievementValidator() {
		validator = getClass().getResource("schema.xsd");
	}

	public void validate(String filename) {
		if(filename != null) {
			Source xml = new StreamSource(new File(filename));

			try {
				SchemaFactory schemaFactory = SchemaFactory
						.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
				Schema schema;
				schema = schemaFactory.newSchema(validator);
				Validator validator = schema.newValidator();

				validator.validate(xml);
				AchievementComposite.validateText.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
				AchievementComposite.validateText.setText(xml.getSystemId() + " is valid");
			} catch (SAXException e) {
				AchievementComposite.validateText.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));
				AchievementComposite.validateText.setText(xml.getSystemId() + " is NOT valid\n\n" + "Reason: " + e.getLocalizedMessage());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
