package tempest.app.manager.composite;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Button;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.layout.FormAttachment;

import tempest.app.manager.GameManager;
import tempest.app.manager.utils.ManagerConstants;
import tempest.game.arena.core.gestures.GestureLibraries;
import tempest.game.arena.core.gestures.GestureLibrary;
import tempest.game.arena.core.gestures.GestureStroke;

import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.widgets.Menu;


public class GestureComposite extends Composite {
	private Text gestureGroupNameText;
	private Text fileText;
	public Label statusBar;
	private List list;
	private GameManager owner;

	private GestureLibrary library;
	private GestureCanvas canvas;
	public static Label gestureName;
	private Combo styleCombo;
	private Combo typeCombo;
	private Label countText;

	public static String filename;
	private Menu gestureProposal;

	public GestureComposite(Composite parent, int style, GameManager owner) {
		super(parent, style);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				try {
					save(false);
				} catch (Exception ex) {
					// TODO: handle exception
				}
			}
		});
		this.owner = owner;

		setLayout(new FormLayout());

		SashForm sashForm = new SashForm(this, SWT.NONE);
		FormData fd_sashForm = new FormData();
		fd_sashForm.bottom = new FormAttachment(100, -20);
		fd_sashForm.right = new FormAttachment(100, -5);
		fd_sashForm.top = new FormAttachment(0, 5);
		fd_sashForm.left = new FormAttachment(0, 5);
		sashForm.setLayoutData(fd_sashForm);

		list = new List(sashForm, SWT.BORDER);

		Menu menu = new Menu(list);
		list.setMenu(menu);

		MenuItem mntmRemove = new MenuItem(menu, SWT.NONE);
		mntmRemove.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				removeGestureFromLibrary();
			}
		});
		mntmRemove.setImage(SWTResourceManager.getImage(GestureComposite.class, "/tempest/app/assets/remove.png"));
		mntmRemove.setText("Remove");
		
		MenuItem mntmRemoveEntry = new MenuItem(menu, SWT.NONE);
		mntmRemoveEntry.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				removeGesturesEntryFromLibrary();
			}
		});
		mntmRemoveEntry.setImage(SWTResourceManager.getImage(GestureComposite.class, "/tempest/app/assets/delete.png"));
		mntmRemoveEntry.setText("Remove entry");
		list.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				try {
					String[] name = list.getSelection()[0].split(" ");
					for (GestureStroke s : library.getGestures(name[0]).get(Integer.valueOf(name[1])).getStrokes()) {
						canvas.setGesture(s.points);
					}
					canvas.setBounds(library.getGestures(name[0]).get(Integer.valueOf(name[1])).getStrokes().get(0).boundingBox);
					canvas.setGesturing(false);
					canvas.redraw();
				} catch (IndexOutOfBoundsException ex) {

				}
			}
		});

		canvas = new GestureCanvas(sashForm, SWT.BORDER | SWT.DOUBLE_BUFFERED);
		canvas.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));

		Composite composite = new Composite(sashForm, SWT.NONE);
		composite.setLayout(new FillLayout(SWT.HORIZONTAL));

		Group group = new Group(composite, SWT.NONE);
		group.setText("Manage");
		group.setLayout(new FormLayout());

		gestureName = new Label(group, SWT.NONE);
		gestureName.setText("No gesture....");
		FormData fd_gestureName = new FormData();
		fd_gestureName.top = new FormAttachment(0, 10);
		fd_gestureName.right = new FormAttachment(100, -10);
		fd_gestureName.left = new FormAttachment(0, 10);
		gestureName.setLayoutData(fd_gestureName);

		Composite composite_1 = new Composite(group, SWT.NONE);
		composite_1.setLayout(new FillLayout(SWT.VERTICAL));
		FormData fd_composite_1 = new FormData();
		fd_composite_1.bottom = new FormAttachment(100, -18);
		fd_composite_1.top = new FormAttachment(0, 31);
		fd_composite_1.right = new FormAttachment(100);
		fd_composite_1.left = new FormAttachment(0);
		composite_1.setLayoutData(fd_composite_1);

		Group group_1 = new Group(composite_1, SWT.NONE);
		group_1.setText("Gesture");
		group_1.setLayout(new GridLayout(2, false));

		Label label_1 = new Label(group_1, SWT.NONE);
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_1.setToolTipText("Must be 3 or more characters.");
		label_1.setText("Name:");

		gestureGroupNameText = new Text(group_1, SWT.BORDER);
		gestureGroupNameText.setText("Right click for proposal...");
		gestureGroupNameText.addFocusListener(new FocusAdapter() {
			@Override
			public void focusGained(FocusEvent e) {
				gestureGroupNameText.setText("");
			}

			@Override
			public void focusLost(FocusEvent e) {
				if(gestureGroupNameText.getText() == "")
					gestureGroupNameText.setText("Right click for proposal...");
			}
		});
		gestureGroupNameText.setToolTipText("Must be 3 or more characters.");
		gestureGroupNameText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		gestureProposal = new Menu(gestureGroupNameText);
		gestureGroupNameText.setMenu(gestureProposal);
		new Label(group_1, SWT.NONE);

		Button button = new Button(group_1, SWT.NONE);
		button.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				addGestureToLibrary();
			}
		});
		button.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		button.setText("Add");
		button.setImage(SWTResourceManager.getImage(GestureComposite.class, "/tempest/app/assets/add.png"));

		Group group_2 = new Group(composite_1, SWT.NONE);
		group_2.setText("Library");
		group_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		group_2.setLayout(new GridLayout(2, false));

		Label label_2 = new Label(group_2, SWT.NONE);
		label_2.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_2.setText("File:");

		fileText = new Text(group_2, SWT.BORDER | SWT.READ_ONLY);
		fileText.setText("no file loaded...");
		fileText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));

		Label label_3 = new Label(group_2, SWT.NONE);
		label_3.setText("Gestures count:");

		countText = new Label(group_2, SWT.NONE);
		countText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		countText.setText("0");
		countText.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));

		Label label_5 = new Label(group_2, SWT.NONE);
		label_5.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_5.setToolTipText("SENSITIVE and INVARIANT are only for SEQUENCE SENSITIVE gestures!\r\n\r\nINVARIANT:\tGesture can be recognized at 1 direction\r\nSENSITIVE:\tGesture can be recognized at most 2 directions\r\nSENSITIVE 4:\tGesture can be recognized at most 4 directions\r\nSENSITIVE 8:\tGesture can be recognized at most 8 directions");
		label_5.setText("Orientation style:");

		styleCombo = new Combo(group_2, SWT.READ_ONLY);
		styleCombo.setToolTipText("SENSITIVE and INVARIANT are only for SEQUENCE SENSITIVE gestures!\r\n\r\nINVARIANT:\tGesture can be recognized at 1 direction\r\nSENSITIVE:\t\tGesture can be recognized at most 2 directions\r\nSENSITIVE 4:\tGesture can be recognized at most 4 directions\r\nSENSITIVE 8:\tGesture can be recognized at most 8 directions");
		styleCombo.setItems(new String[] {"Invariant", "Sensitive", "Sensitive 4", "Sensitive 8"});
		styleCombo.setEnabled(false);
		GridData gd_styleCombo = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_styleCombo.widthHint = 86;
		styleCombo.setLayoutData(gd_styleCombo);

		Label label_6 = new Label(group_2, SWT.NONE);
		label_6.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_6.setToolTipText("INVARIANT: No stroke litim gestures are currently allowed.\r\nSENSITIVE: Only single stroke gestures are currently alowed.");
		label_6.setText("Sequence type:");

		typeCombo = new Combo(group_2, SWT.READ_ONLY);
		typeCombo.setToolTipText("INVARIANT: No stroke litim gestures are currently allowed.");
		typeCombo.setItems(new String[] {"Invariant", "Sensitive"});
		typeCombo.setEnabled(false);
		typeCombo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		sashForm.setWeights(new int[] {1, 2, 1});

		statusBar = new Label(this, SWT.NONE);
		FormData fd_statusBar = new FormData();
		fd_statusBar.right = new FormAttachment(100);
		fd_statusBar.bottom = new FormAttachment(100, -4);
		fd_statusBar.left = new FormAttachment(sashForm, 0, SWT.LEFT);
		statusBar.setLayoutData(fd_statusBar);

	}

	public void createNewLibrary() {
		String savename = "";

		FileDialog save = new FileDialog(owner.shell, SWT.SAVE);
		save.setOverwrite(true);
		save.setText("Creating a new library");
		save.setFilterExtensions(new String[]{"*.gestures", "*.*"});
		save.setFilterNames(new String[]{"Gestures(*.gestures)", "All files(*.*)"});

		savename = save.open();

		if (savename == null)
			return;

		owner.filename = savename;

		library = GestureLibraries.fromFile(owner.filename);
		library.load();

		canvas.setLibrary(library);

		fillGestureList();
		updateLibraryGroup();
	}

	private void savePrompt() {
		if (owner.shell.getModified() == true) {
			MessageBox messageBox = new MessageBox(owner.shell, SWT.ICON_QUESTION | SWT.YES | SWT.NO);
			messageBox.setMessage("Save unsaved changes?");
			messageBox.setText("Save " + filename + "?");
			int response = messageBox.open();
			if (response == SWT.YES) {
				save(false);
			}
			return;
		}
	}

	public void save(boolean saveAs) {
		String savename = "";
		if (saveAs && filename != null) {
			FileDialog save = new FileDialog(owner.shell, SWT.SAVE);
			save.setOverwrite(true);
			save.setText("Saving " + filename + " as");
			save.setFileName(filename);
			save.setFilterExtensions(new String[]{"*.gestures", "*.*"});
			save.setFilterNames(new String[]{"Gestures(*.gestures)", "All files(*.*)"});

			savename = save.open();
		} else {
			savename = filename;
		}

		if(savename == null) {
			return;
		}

		library.save();

		openLibrary(savename);
	}


	public void openLibrary(String url) {
		String input;
		if(filename != null)
			savePrompt();
		if (url == null) {
			FileDialog open = new FileDialog(owner.shell, SWT.OPEN);
			open.setFilterExtensions(new String[]{"*.gestures", "*.*"});
			open.setFilterNames(new String[]{"Gestures(*.gestures)", "All files(.*.)"});
			open.setFilterIndex(0);
			open.setText("Open gesture library");

			input = open.open();
		} else {
			input = url;
		}

		if (input == null)
			input = filename;
		filename = input;

		library = GestureLibraries.fromFile(filename);
		library.load();

		canvas.setLibrary(library);

		statusBar.setText(filename + " successful loaded.");

		fillGestureList();
		updateLibraryGroup();
	}

	private void fillGestureList() {
		list.removeAll();
		if(!(filename == null) && !library.equals(null)) {
			if(library.getGestureEntries().size() > 0) {
				list.setEnabled(true);
				for (String s : library.getGestureEntries()) {
					for (int i = 0; i < library.getGestures(s).size; i++) {
						list.add(s + " " + i);
					}
				}
			}
		}
	}

	private void updateFileText() {
		fileText.setText(filename);
		fileText.setMessage(filename);
	}

	private void updateCountText() {
		if(list.getItemCount() > 0)
			countText.setForeground(SWTResourceManager.getColor(SWT.COLOR_GREEN));
		else
			countText.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));
		countText.setText(Integer.toString(list.getItemCount()));
	}

	private void updateLibraryGroup() {
		updateFileText();
		updateCountText();
		updateStyleCombo();
		updateTypeCombo();

		generateThumbs(ManagerConstants.PROGRAM_DATA, 16, 16);

		for (MenuItem item : gestureProposal.getItems()) {
			item.dispose();
		}
		for (final String s : library.getGestureEntries()) {
			MenuItem item = new MenuItem(gestureProposal, SWT.NONE);
			item.setText(s);
			item.setImage(SWTResourceManager.getImage("C:\\Users\\Asen\\AppData\\Roaming\\Tempest\\" + s + ".png"));
			item.addSelectionListener(new SelectionAdapter() {
				@Override
				public void widgetSelected(SelectionEvent e) {
					gestureGroupNameText.setText(s);
				}
			});
		}
	}

	private void updateTypeCombo() {
		switch (library.getSequenceType()) {
		case 1:
			typeCombo.select(0);
			break;
		case 2:
			typeCombo.select(1);
			break;
		}
	}

	private void updateStyleCombo() {
		switch (library.getOrientationStyle()) {
		case 1:
			styleCombo.select(0);
			break;
		case 2:
			styleCombo.select(1);
			break;
		case 4:
			styleCombo.select(2);
			break;
		case 8:
			styleCombo.select(3);
			break;
		}
	}

	public void addGestureToLibrary() {
		if (gestureGroupNameText.getText().length() > 3 && canvas.getInput() != null) {
			library.addGesture(gestureGroupNameText.getText(), canvas.getInput());
			gestureGroupNameText.setText("");
			owner.shell.setModified(true);

			updateLibraryGroup();
			fillGestureList();
		}
	}

	public void removeGestureFromLibrary() {
		if(list.getSelectionCount() <= 0)
			return;
		else {
			String[] name = list.getSelection()[0].split(" ");
			library.getGestures(name[0]).removeIndex(Integer.valueOf(name[1]));
			canvas.clear();
			owner.shell.setModified(true);
		}
		fillGestureList();
		updateLibraryGroup();
	}

	public void removeGesturesEntryFromLibrary() {
		if(list.getSelectionCount() <= 0) {
			return;
		} else {
			String[] name = list.getSelection()[0].split(" ");
			library.removeEntry(name[0]);
			canvas.clear();
			owner.shell.setModified(true);	
		}
		fillGestureList();
		updateLibraryGroup();
	}

	public void updateComposite() {
		openLibrary(filename);
	}

	public void generateThumbs(String folder, int width, int height) {
		canvas.generateThumbs(folder, width, height);
	}

	@Override
	protected void checkSubclass() {}
}
