package tempest.app.manager.factories;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Link;
import org.eclipse.wb.swt.SWTResourceManager;

import tempest.app.manager.GameManager;
import tempest.app.manager.GameManager.Layouts;
import tempest.app.manager.composite.GestureComposite;
import tempest.app.manager.dialogs.GenerateThumbnails;
import tempest.app.manager.utils.Configuration;

public class ElementsFactory {

	public static final void createGestureLink(final Composite parent, final String name, final GameManager owner) {
		Label link = new Label(parent, SWT.BOLD);
		link.setText(name);
		link.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));

		Button generate = new Button(parent, SWT.NONE);
		generate.setText("Generate thumbnails");
		generate.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		generate.setImage(SWTResourceManager.getImage(GameManager.class, "/tempest/app/assets/image.png"));
		generate.addSelectionListener(new SelectionAdapter() {
			
			@Override
			public void widgetSelected(SelectionEvent e) {
				GestureComposite.filename = Configuration.asString("Project.gestures", "") + name;
				GameManager.gestures.updateComposite();
				GenerateThumbnails dialog = new GenerateThumbnails(owner);
				int res = dialog.open();
				System.out.println(res);
				System.out.println("Generate " + name + " thumbs");
			}
		});
		
		Button edit = new Button(parent, SWT.NONE);
		edit.setText("Edit");
		edit.setImage(SWTResourceManager.getImage(GameManager.class, "/tempest/app/assets/edit.png"));
		edit.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		edit.addSelectionListener(new SelectionAdapter() {
			
			@Override
			public void widgetSelected(SelectionEvent e) {
				System.out.println("Edit " + name);
				GestureComposite.filename = Configuration.asString("Project.gestures", "") + name;
				owner.switchTo(Layouts.GESTURES);
			}
		});
		
		Button remove = new Button(parent, SWT.NONE);
		remove.setText("Delete");
		remove.setImage(SWTResourceManager.getImage(GameManager.class, "/tempest/app/assets/delete.png"));
		remove.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		remove.setEnabled(false);
		remove.addSelectionListener(new SelectionAdapter() {
			
			@Override
			public void widgetSelected(SelectionEvent e) {
				System.out.println("Delete " + name);
			}
		});
	}
	
	public static final void createAchievementLink(final Composite parent, final String name, final GameManager owner) {
		Link link = new Link(parent, SWT.NONE);
		link.setText("<a>" + name + "</a>");
		link.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		link.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				System.out.println("Click on " + name);
				GameManager.achievements.openAchievements(name);
				owner.switchTo(Layouts.ACHIEVEMENTS);
			}
		});
	}
}
