package tempest.app.manager.factories;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;

public class GoalFactory {
	
	public void addGoalToGroup(Group parent, String type, String value) {
		Label goalType = new Label(parent, SWT.NONE);
		goalType.setText(type);
		goalType.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		goalType.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label goal = new Label(parent, SWT.NONE);
		goal.setText(value);
		goal.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		goal.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Button button = new Button(parent, SWT.NONE);
		button.setText("Remove");
		button.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
	}
	
	public void addEditFields(Group parent) {
		final Combo combo = new Combo(parent, SWT.READ_ONLY);
		combo.setItems(new String[] {"Points", "Abilities"});
		combo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		final Text text = new Text(parent, SWT.BORDER);
		text.addFocusListener(new FocusListener() {
			
			@Override
			public void focusLost(FocusEvent arg0) {
				if(text.getText().length() == 0 || text.getText().contains("Enter"))
					text.setText("Enter goal value...");
			}
			
			@Override
			public void focusGained(FocusEvent arg0) {
				text.setText("");
			}
		});
		text.setText("Enter goal value...");
		text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		text.addListener(SWT.Verify, new Listener() {
			public void handleEvent(Event e) {
				try {
					Integer.parseInt(e.text);
				} catch (NumberFormatException nfe) {
					e.doit = false;
				}
			}
		});

		Button button = new Button(parent, SWT.NONE);
		button.setText("Add");
		button.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		button.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if(combo.getSelectionIndex() != -1) {
					
				}
			}
		});
	}
}
