package tempest.app.manager.wizard;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.ModifyEvent;

import tempest.app.manager.utils.Configuration;

/** Project name Wizard page (First wizard page)
 * 
 * @author Asen Lekov <asenlekoff@gmail.com>
 * @since 01/21/2013
 * @version 1.2
 */
public class FirstProjectName extends WizardPage {
	private static Text txtPogopainter;

	public FirstProjectName() {
		super("wizardPage");
		setTitle("Step 1: Project name");
		setDescription("Enter project name");
		
		Configuration.putProperty("Project.name", "HumbleAdventure");
	}
	
	public void createControl(Composite parent) {
		Composite container = new Composite(parent, SWT.NULL);

		setControl(container);
		container.setLayout(new GridLayout(1, false));

		txtPogopainter = new Text(container, SWT.BORDER);
		txtPogopainter.setEnabled(false);
		txtPogopainter.setText("HumbleAdventure");
		txtPogopainter.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				Text text = (Text) e.widget;
				if(text.getText().length() > 6) {
					setPageComplete(true);
				} else {
					setPageComplete(false);
				}
				Configuration.putProperty("Project.name", text.getText());
				Configuration.saveInstance();
			}
		});
		txtPogopainter.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
	}
}
