package tempest.app.manager.wizard;

import org.eclipse.jface.wizard.Wizard;
import org.eclipse.jface.wizard.WizardPage;

/** Project Wizard loader
 * 
 * @author Asen Lekov <asenlekoff@gmail.com>
 * @since 01/21/2013
 * @version 1.0
 *
 */
public class ManagerWizard extends Wizard {
	WizardPage project;
	WizardPage selection;
	WizardPage review;
	
	public ManagerWizard() {
		super();
		setNeedsProgressMonitor(true);
		setWindowTitle("Game manager wizard");
	}

	@Override
	public void addPages() {
		project = new FirstProjectName();
		selection = new SecondRootSelection();
		review = new ThirdFileReview();
		
		addPage(project);
		addPage(selection);
		addPage(review);
	}

	@Override
	public boolean performFinish() {
		System.out.println("Finish");
		return project.isPageComplete() && selection.isPageComplete() && review.isPageComplete();
	}
}
